blob: 8b83990e22faa09c90fa8de73f815431a6eccde4 [file] [log] [blame]
Ed Warnickecb9cada2015-12-08 15:45:58 -07001# Copyright (c) 2015 Cisco and/or its affiliates.
2# Licensed under the Apache License, Version 2.0 (the "License");
3# you may not use this file except in compliance with the License.
4# You may obtain a copy of the License at:
5#
6# http://www.apache.org/licenses/LICENSE-2.0
7#
8# Unless required by applicable law or agreed to in writing, software
9# distributed under the License is distributed on an "AS IS" BASIS,
10# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11# See the License for the specific language governing permissions and
12# limitations under the License.
13
14#
15# Copyright (c) 2007-2008 Eliot Dresselhaus
16#
17# Permission is hereby granted, free of charge, to any person obtaining
18# a copy of this software and associated documentation files (the
19# "Software"), to deal in the Software without restriction, including
20# without limitation the rights to use, copy, modify, merge, publish,
21# distribute, sublicense, and/or sell copies of the Software, and to
22# permit persons to whom the Software is furnished to do so, subject to
23# the following conditions:
24#
25# The above copyright notice and this permission notice shall be
26# included in all copies or substantial portions of the Software.
27#
28# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
29# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
30# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
31# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
32# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
33# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
34# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
35#
36
37######################################################################
38# Collect makefile fragments
39######################################################################
40
41# Scripts require non-POSIX parts of bash
42SHELL := /bin/bash
43
44# Where this makefile lives
45MU_BUILD_ROOT_DIR = $(shell pwd)
46MU_BUILD_NAME = $(shell basename $(MU_BUILD_ROOT_DIR))
47
48# Search path (e.g. multiple directories) where sources are found.
49SOURCE_PATH =
50
51# Pick up user's definitions for variables e.g. SOURCE_PATH, etc.
52-include build-config.mk
53
54MU_BUILD_ROOT_NAME = $(shell basename $(MU_BUILD_ROOT_DIR))
55MU_BUILD_DATA_DIR_NAME = build-data
56
57ABSOLUTE_SOURCE_PATH = $(foreach d,$(SOURCE_PATH),$(shell cd $(d) && pwd))
58
59SOURCE_PATH_BUILD_ROOT_DIRS = $(addsuffix /$(MU_BUILD_NAME),$(ABSOLUTE_SOURCE_PATH))
60SOURCE_PATH_BUILD_DATA_DIRS = $(addsuffix /$(MU_BUILD_DATA_DIR_NAME),$(ABSOLUTE_SOURCE_PATH))
61
62# For tools use build-root as source path, otherwise use given source path
63FIND_SOURCE_PATH = \
64 $(if $(is_build_tool), \
65 $(SOURCE_PATH_BUILD_ROOT_DIRS) $(MU_BUILD_ROOT_DIR), \
66 $(SOURCE_PATH_BUILD_DATA_DIRS))
67
68# First search given source path, then default to build-root
69FULL_SOURCE_PATH = $(SOURCE_PATH_BUILD_DATA_DIRS) $(MU_BUILD_ROOT_DIR)
70
71# Misc functions
72is_in_fn = $(strip $(filter $(1),$(2)))
73last_fn = $(lastword $1)
74chop_fn = $(wordlist 2,$(words $1),x $1)
75uniq_fn = $(strip $(if $1,$(call uniq_fn,$(call chop_fn,$1)) \
76 $(if $(filter $(call last_fn,$1),$(call chop_fn,$1)),,$(call last_fn,$1))))
77ifdef3_fn = $(if $(patsubst undefined,,$(origin $(1))),$(3),$(2))
78ifdef_fn = $(call ifdef3_fn,$(1),$(2),$($(1)))
79
80_mu_debug = $(warning "$(1) = $($(1))")
81
82$(foreach d,$(FIND_SOURCE_PATH), \
83 $(eval _mu_package_mk_in_$(d) = $(shell find $(d)/packages/*.mk 2> /dev/null)) \
84 $(eval _mu_srcdirs_in_$(d) = \
85 $(shell find $(d)/.. \
86 -maxdepth 1 \
87 -type d \
88 -and -not -name ".." \
89 -and -not -name $(MU_BUILD_ROOT_NAME) \
90 -and -not -name $(MU_BUILD_DATA_DIR_NAME))) \
91 $(eval _mu_non_package_files_in_$(d) = \
92 $(shell find $(d)/packages \
93 -type f \
94 -and -not -name '*.mk' \
95 -and -not -name '*~' 2> /dev/null)) \
96 $(foreach p,$(patsubst %.mk,%,$(notdir $(_mu_package_mk_in_$(d)))), \
97 $(eval _mu_package_dir_$(p) = $(d)) \
98 $(eval _mu_package_mk_$(p) = $(d)/packages/$(p).mk) \
99 ) \
100 $(foreach p,$(notdir $(_mu_srcdirs_in_$(d))), \
101 $(eval _mu_package_srcdir_$(p) = $(shell cd $(d)/../$(p) && pwd)) \
102 ) \
103)
104
105# Find root directory for package based on presence of package .mk
106# makefile fragment on source path.
107_find_build_data_dir_for_package_fn = $(shell \
108 set -eu$(BUILD_DEBUG) ; \
109 for d in $(FIND_SOURCE_PATH) ; do \
110 f="$${d}/packages/$(1).mk" ; \
111 [[ -f $${f} ]] && echo `cd $${d} && pwd` && exit 0 ; \
112 done ; \
113 echo "")
114find_build_data_dir_for_package_fn = $(call ifdef_fn,_mu_package_dir_$(1),)
115
116# dir/PACKAGE
117_find_source_fn = $(shell \
118 set -eu$(BUILD_DEBUG) ; \
119 d="$(call find_build_data_dir_for_package_fn,$(1))" ; \
120 [[ -n "$${d}" ]] && d="$${d}/../$(1)" ; \
121 echo "$${d}")
122find_source_fn = $(call ifdef3_fn,_mu_package_dir_$(1),,$(_mu_package_dir_$(1))/../$(1))
123
124# Find given FILE in source path as build-data/packages/FILE
125find_package_file_fn = $(shell \
126 set -eu$(BUILD_DEBUG) ; \
127 d="$(call find_build_data_dir_for_package_fn,$(1))" ; \
128 [[ -n "$${d}" ]] && d="$${d}/packages/$(2)" ; \
129 [[ -f "$${d}" ]] && echo "$${d}")
130
131# Find first FILE in source path with name PATH/build-data/FILE
132find_build_data_file_fn = $(shell \
133 set -eu$(BUILD_DEBUG) ; \
134 for d in $(FIND_SOURCE_PATH) ; do \
135 f="$${d}/$(1)" ; \
136 [[ -f $${f} ]] && echo `cd $${d} && pwd`/$(1) && exit 0 ; \
137 done ; \
138 echo "")
139
140######################################################################
141# ARCH, PLATFORM
142######################################################################
143
144NATIVE_ARCH = $(shell gcc -dumpmachine | sed -e 's/\([a-zA-Z_0-9]*\)-.*/\1/')
145
146# Find all platforms.mk that we can, including those from build-root
147$(foreach d,$(FULL_SOURCE_PATH), \
148 $(eval -include $(d)/platforms.mk))
149
150# Platform should be defined somewhere by specifying $($(PLATFORM)_arch)
151ARCH = $(strip $($(PLATFORM)_arch))
152ifeq ($(ARCH),)
153 $(error "Unknown platform `$(PLATFORM)'")
154endif
155
156# map e.g. ppc7450 -> ppc
157BASIC_ARCH = \
158 ${shell case '$(ARCH)' in \
159 (native) echo $(NATIVE_ARCH) ;; \
160 (i*86*) echo i386 ;; \
161 (ppc*|powerpc*) echo ppc ;; \
162 (*) echo '$(ARCH)' ;; \
163 esac }
164
165# x86_64 can be either 32/64. set BIACH=32 to get 32 bit libraries.
166BIARCH = 64
167
168x86_64_libdir = $(BIARCH)
169native_libdir = $($(NATIVE_ARCH)_libdir)
170
171# lib or lib64 depending
172arch_lib_dir = lib$($(BASIC_ARCH)_libdir)
173
174# OS to configure for. configure --host will be set to $(ARCH)-$(OS)
Dave Barach61efa142016-01-22 08:23:09 -0500175# Allow per-platform overrides
176
177OS = $(strip $($(PLATFORM)_os))
178ifeq ($(OS),)
179 OS = mu-linux
180endif
Ed Warnickecb9cada2015-12-08 15:45:58 -0700181
182spu_target = spu
183native_target =
184
185is_native = $(if $(ARCH:native=),,true)
186not_native = $(if $(ARCH:native=),true,)
187
188ARCH_TARGET_tmp = $(call ifdef_fn,$(ARCH)_target,$(ARCH)-$(OS))
189TARGET = $(call ifdef_fn,$(PLATFORM)_target,$(ARCH_TARGET_tmp))
190TARGET_PREFIX = $(if $(not_native),$(TARGET)-,)
191
192# CPU microarchitecture detection.
193# Either set <platform>_march in build-data/platforms/<platform>.mk,
194# or detect and use the build-host instruction set
195
196MARCH = $(strip $($(PLATFORM)_march))
197ifeq ($(MARCH),)
198 ifneq ($(wildcard $(TOOL_INSTALL_DIR)/bin/$(TARGET)-gcc),)
199 TARGET_GCC = $(TOOL_INSTALL_DIR)/bin/$(TARGET)-gcc
200 else ifneq ($(wildcard $(MU_BUILD_ROOT_DIR)/tools/bin/$(TARGET)-gcc),)
201 TARGET_GCC = $(MU_BUILD_ROOT_DIR)/tools/bin/$(TARGET)-gcc
202 endif
203 ifneq ($(TARGET_GCC),)
204 MARCH = $(shell $(TARGET_GCC) -Q --help=target -march=native | grep march | sed -e 's/.*march=[[:space:]]*//')
205 else
206 MARCH = native
207 endif
208else
209 ifeq ($(MARCH),nehalem)
210 override MARCH = corei7
211 else ifeq ($(MARCH),westmere)
212 override MARCH = corei7
213 else ifeq ($(MARCH),sandybridge)
214 override MARCH = corei7-avx
215 else ifeq ($(MARCH),ivybridge)
216 override MARCH = core-avx-i
217 else ifeq ($(MARCH),haswell)
218 override MARCH = core-avx2
219 endif
220endif
221export MARCH
222
Damjan Marion1c80e832016-05-11 23:07:18 +0200223MTUNE = $(strip $($(PLATFORM)_mtune))
224ifeq ($(MTUNE),)
225 MTUNE = generic
226endif
227
Ed Warnickecb9cada2015-12-08 15:45:58 -0700228######################################################################
229# Generic build stuff
230######################################################################
231
232# The package we are currently working on
233PACKAGE = $*
234
235# Build/install tags. This lets you have different CFLAGS/CPPFLAGS/LDFLAGS
236# for e.g. debug versus optimized compiles. Each tag has its own set of build/install
237# areas.
238TAG =
239TAG_PREFIX = $(if $(TAG),$(TAG)-)
240
241# yes you need the space
242tag_var_with_added_space_fn = $(if $($(TAG)_TAG_$(1)),$($(TAG)_TAG_$(1)) )
243
244# TAG=debug for debugging
Dave Barach459a11a2016-03-30 10:24:41 -0400245debug_TAG_CFLAGS = -g -O0 -DCLIB_DEBUG -DFORTIFY_SOURCE=2 -march=$(MARCH) \
246 -fstack-protector-all -fPIC
247debug_TAG_LDFLAGS = -g -O0 -DCLIB_DEBUG -DFORTIFY_SOURCE=2 -march=$(MARCH) \
248 -fstack-protector-all -fPIC
Ed Warnickecb9cada2015-12-08 15:45:58 -0700249
250BUILD_PREFIX_package = build-$(TAG_PREFIX)
251BUILD_PREFIX_tool = build-tool-$(TAG_PREFIX)
252INSTALL_PREFIX = install-$(TAG_PREFIX)
253IMAGES_PREFIX = images-$(TAG_PREFIX)
254
255# Whether we are building a tool or not
256tool_or_package_fn = $(if $(is_build_tool),tool,package)
257
258# Directory where packages are built & installed
259BUILD_DIR = $(MU_BUILD_ROOT_DIR)/$(BUILD_PREFIX_$(call tool_or_package_fn))$(ARCH)
260
261## BURT
262# we will deprecate INSTALL_DIR shortly for DFLT_INSTALL_DIR
263INSTALL_DIR = $(MU_BUILD_ROOT_DIR)/$(INSTALL_PREFIX)$(ARCH)
264# DFLT_INSTALL_DIR used in platforms.mk for $(PLATFORM)_DESTDIR_BASE
265DFLT_INSTALL_DIR := $(MU_BUILD_ROOT_DIR)/$(INSTALL_PREFIX)$(ARCH)
266## BURT
267
268PLATFORM_IMAGE_DIR = $(MU_BUILD_ROOT_DIR)/$(IMAGES_PREFIX)$(PLATFORM)
269
270# $(call VAR,DEFAULT)
271override_var_with_default_fn = $(if $($(1)),$($(1)),$(2))
272
273# $(call if_directory_exists_fn,D1,D2) returns D1 if it exists else D2
274define if_directory_exists_fn
275$(shell if test -d $(1); then echo $(1); else echo $(2); fi)
276endef
277
278# $(call if_file_exists_fn,F1,F2) returns F1 if it exists else F2
279define if_file_exists_fn
280$(shell if test -f $(1); then echo $(1); else echo $(2); fi)
281endef
282
283# Default VAR, package specified override of default PACKAGE_VAR
284package_var_fn = $(call override_var_with_default_fn,$(1)_$(2),$(1))
285
286package_build_dir_fn = $(call package_var_fn,$(1),build_dir)
287
288package_install_dir_fn = \
289 $(if $(is_build_tool),$(TOOL_INSTALL_DIR),$(INSTALL_DIR)/$(call package_build_dir_fn,$(1)))
290
291PACKAGE_BUILD_DIR = \
292 $(BUILD_DIR)/$(call package_build_dir_fn,$(PACKAGE))
293PACKAGE_INSTALL_DIR = \
294 $(call package_install_dir_fn,$(PACKAGE))
295
296# Tools (gcc, binutils, glibc...) are installed here
297TOOL_INSTALL_DIR = $(MU_BUILD_ROOT_DIR)/tools
298
299# Target specific tools go here e.g. mu-build/tools/ppc-mu-linux
300TARGET_TOOL_INSTALL_DIR = $(TOOL_INSTALL_DIR)/$(TARGET)
301
302# Set BUILD_DEBUG to vx or x enable shell command tracing.
303BUILD_DEBUG =
304
305# Message from build system itself (as opposed to make or shell commands)
306build_msg_fn = echo "@@@@ $(1) @@@@"
307
Dave Barachc42508d2016-01-27 09:44:47 -0500308# Allow CCACHE_DIR to be overridden, e.g. in .../build-root/build-config.mk
309ifeq ($(CCACHE_DIR),)
310 CCACHE_DIR=$(MU_BUILD_ROOT_DIR)/.ccache
311endif
312
Ed Warnickecb9cada2015-12-08 15:45:58 -0700313# Always prefer our own tools to those installed on system.
314# Note: ccache-bin must be before tool bin.
315BUILD_ENV = \
Dave Barachc42508d2016-01-27 09:44:47 -0500316 export CCACHE_DIR=$(CCACHE_DIR) ; \
Ed Warnickecb9cada2015-12-08 15:45:58 -0700317 export PATH=$(TOOL_INSTALL_DIR)/ccache-bin:$(TOOL_INSTALL_DIR)/bin:$${PATH} ; \
318 export PATH="`echo $${PATH} | sed -e s/[.]://`" ; \
319 $(if $(not_native),export CONFIG_SITE=$(MU_BUILD_ROOT_DIR)/config.site ;,) \
320 export LD_LIBRARY_PATH=$(TOOL_INSTALL_DIR)/lib64:$(TOOL_INSTALL_DIR)/lib ; \
321 set -eu$(BUILD_DEBUG) ; \
322 set -o pipefail
323
324######################################################################
325# Package build generic definitions
326######################################################################
327
328package_dir_fn = \
329 $(call find_build_data_dir_for_package_fn,$(1))/packages
330
331package_mk_fn = $(call package_dir_fn,$(1))/$(1).mk
332
333### BURT
334
335#next version
336#pkgPhaseDependMacro = $(foreach x,configure build install, \
337 $(eval $(1)_$(x)_depend := $($(1)_depend:%=%-$(x))))
338#version equivalent to original code
339pkgPhaseDependMacro = $(eval $(1)_configure_depend := $($(1)_depend:%=%-install))
340
341### BURT
342
343# Pick up built-root/pre-package-include.mk for all source directories
344$(foreach d,$(SOURCE_PATH_BUILD_ROOT_DIRS), \
345 $(eval -include $(d)/pre-package-include.mk))
346
347$(foreach d,$(addsuffix /packages,$(FIND_SOURCE_PATH)), \
348 $(eval -include $(d)/*.mk) \
349 $(eval ALL_PACKAGES += $(patsubst $(d)/%.mk,%,$(wildcard $(d)/*.mk))) \
350)
351
352# Pick up built-root/post-package-include.mk for all source directories
353$(foreach d,$(SOURCE_PATH_BUILD_ROOT_DIRS), \
354 $(eval -include $(d)/post-package-include.mk))
355
356# Linux specific native build tools
357NATIVE_TOOLS_LINUX = \
358 e2fsimage \
359 e2fsprogs \
360 fakeroot \
361 jffs2 \
362 mkimage \
363 zlib \
364 xz \
365 squashfs
366
367IS_LINUX = $(if $(findstring no,$($(PLATFORM)_uses_linux)),no,yes)
368
369NATIVE_TOOLS_$(IS_LINUX) += $(NATIVE_TOOLS_LINUX)
370
371# only build glibc for linux installs
372CROSS_TOOLS_$(IS_LINUX) += glibc gcc
373
374# must be first for bootstrapping
375NATIVE_TOOLS = findutils make
376
377# basic tools needed for build system
378NATIVE_TOOLS += git automake autoconf libtool texinfo bison flex tar
379
380# needed to compile gcc
381NATIVE_TOOLS += mpfr gmp mpc
382
383# Tool to sign binaries
384NATIVE_TOOLS += sign
385
386# ccache
387NATIVE_TOOLS += ccache
388
389# Tools needed on native host to build for platform
390NATIVE_TOOLS += $(call ifdef_fn,$(PLATFORM)_native_tools,)
391
392# Tools for cross-compiling from native -> ARCH
393CROSS_TOOLS = binutils gcc-bootstrap gdb
394
395# Tools needed on native host to build for platform
396CROSS_TOOLS += $(call ifdef_fn,$(PLATFORM)_cross_tools,)
397
398NATIVE_TOOLS += $(NATIVE_TOOLS_yes)
399CROSS_TOOLS += $(CROSS_TOOLS_yes)
400
401timestamp_name_fn = .mu_build_$(1)_timestamp
402CONFIGURE_TIMESTAMP = $(call timestamp_name_fn,configure)
403BUILD_TIMESTAMP = $(call timestamp_name_fn,build)
404INSTALL_TIMESTAMP = $(call timestamp_name_fn,install)
405
406TIMESTAMP_DIR = $(PACKAGE_BUILD_DIR)
407
408find_newer_files_fn = \
409 "`for i in $(2) ; do \
410 [[ -f $$i && $$i -nt $(1) ]] && echo "$$i" && exit 0; \
411 done ; \
412 exit 0;`"
413
414find_filter = -not -name '*~'
415find_filter += -and -not -path '*/.git*'
416find_filter += -and -not -path '*/.svn*'
417find_filter += -and -not -path '*/.CVS*'
418find_filter += -and -not -path '*/manual/*'
419find_filter += -and -not -path '*/autom4te.cache/*'
420find_filter += -and -not -path '*/doc/all-cfg.texi'
421find_filter += -and -not -path '*/.mu_build_*'
422
423find_newer_filtered_fn = \
424 (! -f $(1) \
425 || -n $(call find_newer_files_fn,$(1),$(3)) \
426 || -n "`find -H $(2) \
427 -type f \
428 -and -newer $(1) \
429 -and \( $(4) \) \
430 -print -quit`")
431
432find_newer_fn = \
433 $(call find_newer_filtered_fn,$(1),$(2),$(3),$(find_filter))
434
435######################################################################
436# Package dependencies
437######################################################################
438
439# This must come before %-configure, %-build, %-install pattern rules
440# or else dependencies will not work.
441
442package_dependencies_fn = \
443 $(patsubst %-install, %, \
444 $(filter %-install,$($(1)_configure_depend)))
445
446PACKAGE_DEPENDENCIES = $(call package_dependencies_fn,$(PACKAGE))
447
448# package specific configure, build, install dependencies
449add_package_dependency_fn = \
450 $(if $($(1)_$(2)_depend), \
451 $(eval $(1)-$(2) : $($(1)_$(2)_depend)))
452
453$(foreach p,$(ALL_PACKAGES), \
454 $(call add_package_dependency_fn,$(p),configure) \
455 $(call add_package_dependency_fn,$(p),build) \
456 $(call add_package_dependency_fn,$(p),install))
457
458TARGETS_RESPECTING_DEPENDENCIES = image_install wipe diff push-all pull-all find-source
459
460# carry over packages dependencies to image install, wipe, pull-all, push-all
461$(foreach p,$(ALL_PACKAGES), \
462 $(if $($(p)_configure_depend), \
463 $(foreach s,$(TARGETS_RESPECTING_DEPENDENCIES), \
464 $(eval $(p)-$(s): \
465 $(addsuffix -$(s), $(call package_dependencies_fn,$(p)))))))
466
467# recursively resolve dependencies
468resolve_dependencies2_fn = $(strip \
469 $(eval __added = $(filter-out $(4), \
470 $(call uniq_fn, \
471 $(foreach l,$(3), \
472 $(call ifdef3_fn,$(l)$(1),,$(call $(2),$($(l)$(1)))) \
473 )))) \
474 $(eval __known = $(call uniq_fn,$(4) $(3) $(__added))) \
475 $(if $(__added), \
476 $(call resolve_dependencies2_fn,$(1),$(2),$(__added),$(__known)), \
477 $(__known)) \
478)
479
480resolve_dependencies_null_fn = $(1)
481
482resolve_dependencies_fn = $(call resolve_dependencies2_fn,$(1),resolve_dependencies_null_fn,$(2))
483
484######################################################################
485# Package configure
486######################################################################
487
488# x86_64 can be either 32/64. set BIACH=32 to get 32 bit libraries.
489BIARCH = 64
490
491x86_64_libdir = $(BIARCH)
492native_libdir = $($(NATIVE_ARCH)_libdir)
493
494# lib or lib64 depending
495arch_lib_dir = lib$($(BASIC_ARCH)_libdir)
496
497# find dynamic linker as absolute path
498TOOL_INSTALL_LIB_DIR=$(TOOL_INSTALL_DIR)/$(TARGET)/$(arch_lib_dir)
499DYNAMIC_LINKER=${shell cd $(TOOL_INSTALL_LIB_DIR); echo ld*.so.*}
500
501# Pad dynamic linker & rpath so elftool will never have to change ELF section sizes.
502# Yes, this is a kludge.
503lots_of_slashes_to_pad_names = "/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////"
504
505# When PLATFORM != native we *always* use our own versions of GLIBC and dynamic linker
Dave Barach61efa142016-01-22 08:23:09 -0500506# Allow per-platform overrides
507CROSS_LDFLAGS = $(strip $($(PLATFORM)_cross_ldflags))
508ifeq ($(CROSS_LDFLAGS),)
509 CROSS_LDFLAGS = \
510 -Wl,--dynamic-linker=$(lots_of_slashes_to_pad_names)$(TOOL_INSTALL_LIB_DIR)/$(DYNAMIC_LINKER) \
511 -Wl,-rpath -Wl,$(lots_of_slashes_to_pad_names)$(TOOL_INSTALL_LIB_DIR)
512endif
Ed Warnickecb9cada2015-12-08 15:45:58 -0700513
514cross_ldflags = $(if $(is_native)$(is_build_tool),,$(CROSS_LDFLAGS) )
515
516# $(call installed_libs_fn,PACKAGE)
517# Return install library directory for given package.
518# Some packages (e.g. openssl) don't install under lib64; instead they use lib
519define installed_lib_fn
520$(call if_directory_exists_fn,
521 $(call package_install_dir_fn,$(1))/$(arch_lib_dir),
522 $(call package_install_dir_fn,$(1))/lib)
523endef
524
525# Set -L and rpath to point to dependent libraries previously built by us.
526installed_libs_fn = \
527 $(foreach i,$(1), \
528 -L$(call installed_lib_fn,$(i)) \
529 -Wl,-rpath -Wl,$(call installed_lib_fn,$(i)))
530
531# As above for include files
532installed_include_fn = $(call package_install_dir_fn,$(1))/include
533
534installed_includes_fn = $(foreach i,$(1),-I$(call installed_include_fn,$(i)))
535
536# By default package CPPFLAGS (to set include path -I) and LDFLAGS (to set link path -L)
537# point at dependent install directories.
538DEFAULT_CPPFLAGS = $(call installed_includes_fn, $(PACKAGE_DEPENDENCIES))
539DEFAULT_LDFLAGS = $(call installed_libs_fn, $(PACKAGE_DEPENDENCIES))
540
541configure_var_fn = \
542 $(call tag_var_with_added_space_fn,$(1))$(call override_var_with_default_fn,$(PACKAGE)_$(1),$(DEFAULT_$(1)))
543configure_ldflags_fn = \
544 $(cross_ldflags)$(call configure_var_fn,LDFLAGS)
545
546# Allow packages to override CPPFLAGS, CFLAGS, and LDFLAGS
547CONFIGURE_ENV = \
548 $(if $(call configure_var_fn,CPPFLAGS), \
549 CPPFLAGS="$(CPPFLAGS) $(call configure_var_fn,CPPFLAGS)") \
550 $(if $(call configure_var_fn,CFLAGS), \
551 CFLAGS="$(CFLAGS) $(call configure_var_fn,CFLAGS)") \
552 $(if $(call configure_var_fn,CCASFLAGS), \
553 CCASFLAGS="$(CCASFLAGS) $(call configure_var_fn,CCASFLAGS)") \
554 $(if $(call configure_ldflags_fn), \
555 LDFLAGS="$(LDFLAGS) $(call configure_ldflags_fn)") \
556 $(if $($(PACKAGE)_configure_env),$($(PACKAGE)_configure_env))
557
558### BURT
559# only partially used now (used in a few .mk files)
560ifeq ($(is_build_tool),yes)
561prefix = $(PACKAGE_INSTALL_DIR)
562libdir = $(PACKAGE_INSTALL_DIR)/$(arch_lib_dir)
563libexecdir = $(PACKAGE_INSTALL_DIR)/usr/libexec
564DESTDIR = /
565else
566# Eventually simplify this with no per package DESTDIR or prefix
567ppdMacro = $(if $(PER_PACKAGE_DESTDIR),$(call package_build_dir_fn,$(1)))
568pppMacro = $(if $(PER_PACKAGE_PREFIX),$(call package_build_dir_fn,$(1)))
569prefixMacro = $($(PLATFORM)_PREFIX_BASE)/$(pppMacro)
570prefix = $(call prefixMacro,$(PACKAGE))
571libdir = $($(PLATFORM)_LIBDIR)
572libexecdir = $($(PLATFORM)_LIBEXECDIR)
573destdirMacro = $($(PLATFORM)_DESTDIR_BASE)$(ppdMacro)
574DESTDIR = $(call destdirMacro,$(PACKAGE))
575endif
576### BURT
577### dbarach
578image_extra_dependencies = $($(PLATFORM)_image_extra_dependencies)
579### dbarach
580
581configure_package_gnu = \
582 s=$(call find_source_fn,$(PACKAGE_SOURCE)) ; \
583 if [ ! -f $$s/configure ] ; then \
584 autoreconf -i -f $$s ; \
585 fi ; \
586 cd $(PACKAGE_BUILD_DIR) ; \
587 env $(CONFIGURE_ENV) \
588 $$s/configure \
589 $(if $($(PACKAGE)_configure_host_and_target), \
590 $($(PACKAGE)_configure_host_and_target), \
591 $(if $(not_native),--host=$(TARGET),)) \
592 $(if $($(PACKAGE)_configure_prefix), \
593 $($(PACKAGE)_configure_prefix), \
594 --libdir=$(PACKAGE_INSTALL_DIR)/$(arch_lib_dir) \
595 --prefix=$(PACKAGE_INSTALL_DIR)) \
596 $($(PACKAGE)_configure_args) \
597 $($(PACKAGE)_configure_args_$(PLATFORM))
598
599configure_package = \
600 $(call build_msg_fn,Configuring $(PACKAGE) in $(PACKAGE_BUILD_DIR)) ; \
601 mkdir -p $(PACKAGE_BUILD_DIR) ; \
602 $(if $($(PACKAGE)_configure), \
603 $($(PACKAGE)_configure), \
604 $(configure_package_gnu))
605
606# Tools (e.g. gcc, binutils, gdb) required a platform to build for
607check_platform = \
608 is_tool="$(is_build_tool)" ; \
609 is_cross_package="$(findstring $(PACKAGE),$(CROSS_TOOLS))" ; \
610 is_arch_native="$(if $(subst native,,$(ARCH)),,yes)" ; \
611 if [ "$${is_tool}" == "yes" \
612 -a "$${is_cross_package}" != "" \
613 -a "$${is_arch_native}" != "" ]; then \
614 $(call build_msg_fn,You must specify PLATFORM for building tools) ; \
615 exit 1 ; \
616 fi ; \
617 : check that platform gcc can be found ; \
618 target_gcc=gcc ; \
619 if [ "$${is_arch_native}" != "yes" ] ; then \
620 target_gcc=$(TARGET)-gcc ; \
621 fi ; \
622 if [ "$${is_tool}" != "yes" \
623 -a "$${is_arch_native}" != "yes" \
624 -a ! -x "`which 2> /dev/null $${target_gcc}`" ] ; then \
625 $(call build_msg_fn, \
626 No cross-compiler found for platform $(PLATFORM) target $(TARGET); \
627 try make PLATFORM=$(PLATFORM) install-tools) ; \
628 exit 1 ; \
629 fi
630
631configure_check_timestamp = \
632 @$(BUILD_ENV) ; \
633 $(check_platform) ; \
634 mkdir -p $(PACKAGE_BUILD_DIR) ; \
635 mkdir -p $(PACKAGE_INSTALL_DIR) ; \
636 conf="$(TIMESTAMP_DIR)/$(CONFIGURE_TIMESTAMP)" ; \
637 dirs="$(call package_mk_fn,$(PACKAGE)) \
638 $(wildcard $(call find_source_fn,$(PACKAGE_SOURCE))/configure) \
639 $(MU_BUILD_ROOT_DIR)/config.site" ; \
640 if [[ $(call find_newer_fn, $${conf}, $${dirs}, $?) ]]; then \
641 $(configure_package) ; \
642 touch $${conf} ; \
643 else \
644 $(call build_msg_fn,Configuring $(PACKAGE): nothing to do) ; \
645 fi
646
647.PHONY: %-configure
648%-configure: %-find-source
649 $(configure_check_timestamp)
650
651######################################################################
652# Package build
653######################################################################
654
655linux_n_cpus = `grep '^processor' /proc/cpuinfo | wc -l`
656
657MAKE_PARALLEL_JOBS = \
658 -j $(shell \
659 if [ -f /proc/cpuinfo ] ; then \
Damjan Marion2e89a892016-03-24 17:19:27 +0100660 expr 2 '*' $(linux_n_cpus) ; \
Ed Warnickecb9cada2015-12-08 15:45:58 -0700661 else \
662 echo 1 ; \
663 fi)
664
665MAKE_PARALLEL_FLAGS = $(if $($(PACKAGE)_make_parallel_fails),,$(MAKE_PARALLEL_JOBS))
666
667# Make command shorthand for packages & tools.
668PACKAGE_MAKE = \
669 $(MAKE) \
670 -C $(PACKAGE_BUILD_DIR) \
671 $($(PACKAGE)_make_args) \
672 $(MAKE_PARALLEL_FLAGS)
673
674build_package = \
675 $(call build_msg_fn,Building $* in $(PACKAGE_BUILD_DIR)) ; \
676 mkdir -p $(PACKAGE_BUILD_DIR) ; \
677 cd $(PACKAGE_BUILD_DIR) ; \
678 $(if $($(PACKAGE)_build), \
679 $($(PACKAGE)_build), \
680 $(PACKAGE_MAKE))
681
682build_check_timestamp = \
683 @$(BUILD_ENV) ; \
684 comp="$(TIMESTAMP_DIR)/$(BUILD_TIMESTAMP)" ; \
685 conf="$(TIMESTAMP_DIR)/$(CONFIGURE_TIMESTAMP)" ; \
686 dirs="$(call find_source_fn,$(PACKAGE_SOURCE)) \
687 $($(PACKAGE)_build_timestamp_depends) \
688 $(if $(is_build_tool),,$(addprefix $(INSTALL_DIR)/,$(PACKAGE_DEPENDENCIES)))" ; \
689 if [[ $${conf} -nt $${comp} \
690 || $(call find_newer_fn, $${comp}, $${dirs}, $?) ]]; then \
691 $(build_package) ; \
692 touch $${comp} ; \
693 else \
694 $(call build_msg_fn,Building $(PACKAGE): nothing to do) ; \
695 fi
696
697.PHONY: %-build
698%-build: %-configure
699 $(build_check_timestamp)
700
701.PHONY: %-rebuild
702%-rebuild: %-wipe %-build
703 @ :
704
705######################################################################
706# Package install
707######################################################################
708
709install_package = \
710 : by default, for non-tools, remove any previously installed bits ; \
711 $(if $(is_build_tool)$($(PACKAGE)_keep_instdir), \
712 true, \
713 rm -rf $(PACKAGE_INSTALL_DIR)); \
714 mkdir -p $(PACKAGE_INSTALL_DIR) ; \
715 $(if $($(PACKAGE)_pre_install),$($(PACKAGE)_pre_install),true); \
716 $(if $($(PACKAGE)_install), \
717 $($(PACKAGE)_install), \
718 $(PACKAGE_MAKE) \
719 $($(PACKAGE)_install_args) \
720 install) ; \
721 $(if $($(PACKAGE)_post_install),$($(PACKAGE)_post_install),true)
722
723install_check_timestamp = \
724 @$(BUILD_ENV) ; \
725 inst=$(TIMESTAMP_DIR)/$(INSTALL_TIMESTAMP) ; \
726 dirs="$(PACKAGE_BUILD_DIR) \
727 $($(PACKAGE)_install_dependencies)" ; \
728 if [[ $(call find_newer_fn, $${inst}, $${dirs}, $?) ]]; then \
729 $(call build_msg_fn,Installing $(PACKAGE)) ; \
730 $(install_package) ; \
731 touch $${inst} ; \
732 else \
733 $(call build_msg_fn,Installing $(PACKAGE): nothing to do) ; \
734 fi
735
736.PHONY: %-install
737%-install: %-build
738 $(install_check_timestamp)
739
740######################################################################
741# Source code managment
742######################################################################
743
744GIT = git
745
746# Maps package name to source directory root.
747# Multiple packages may use a single source tree.
748# For example, gcc-bootstrap package shares gcc source.
749PACKAGE_SOURCE = $(if $($(PACKAGE)_source),$($(PACKAGE)_source),$(PACKAGE))
750
751# Use git to download source if directory is not found
752find_source_for_package = \
753 @$(BUILD_ENV) ; \
754 $(call build_msg_fn,Arch for platform '$(PLATFORM)' is $(ARCH)) ; \
755 $(call build_msg_fn,Finding source for $(PACKAGE)) ; \
756 s="$(call find_source_fn,$(PACKAGE_SOURCE))" ; \
757 [[ -z "$${s}" ]] \
758 && $(call build_msg_fn,Package $(PACKAGE) not found with path $(SOURCE_PATH)) \
759 && exit 1; \
760 mk="$(call find_build_data_dir_for_package_fn,$(PACKAGE_SOURCE))/packages/$(PACKAGE).mk"; \
761 $(call build_msg_fn,Makefile fragment found in $${mk}) ; \
762 if [ ! -d "$${s}" ] ; then \
763 d=`dirname $${mk}` ; \
764 i=`cd $${d}/.. && ($(GIT) config remote.origin.url || \
765 awk '/URL/ { print $$2; }' .git/remotes/origin)`; \
766 g=`dirname $${i}` ; \
767 $(call build_msg_fn,Fetching source: $(GIT) clone $${g}/$(PACKAGE_SOURCE) $$s) ; \
768 if ! $(GIT) clone $${g}/$(PACKAGE_SOURCE) $$s; then \
769 $(call build_msg_fn,No source for $(PACKAGE) in $${g}); \
770 exit 1; \
771 fi ; \
Dave Barach7210e942015-12-15 18:57:51 -0500772 $(call build_msg_fn,Fix file dates in $${g}/$(PACKAGE_SOURCE)) ; \
Ed Warnickecb9cada2015-12-08 15:45:58 -0700773 (cd $${s} ; $(MU_BUILD_ROOT_DIR)/autowank --touch) ; \
774 fi ; \
775 s=`cd $${s} && pwd` ; \
776 $(call build_msg_fn,Source found in $${s})
777
778.PHONY: %-find-source
779%-find-source:
780 $(find_source_for_package)
781
782.PHONY: %-push %-pull %-push-all %-pull-all
783%-push %-pull %-push-all %-pull-all:
784 @$(BUILD_ENV) ; \
785 push_or_pull=$(patsubst %-all,%,$(subst $(PACKAGE)-,,$@)) ; \
786 $(call build_msg_fn,Git $${push_or_pull} source for $(PACKAGE)) ; \
787 s=$(call find_source_fn,$(PACKAGE_SOURCE)) ; \
788 if [ "x$$s" = "x" ]; then \
789 $(call build_msg_fn,No source for $(PACKAGE)) ; \
790 exit 1; \
791 fi ; \
792 cd $$s && $(GIT) $${push_or_pull}
793
794# Pull all packages for platform
795.PHONY: pull-all
796pull-all:
797 @$(BUILD_ENV) ; \
798 $(call build_msg_fn,Git pull build system) ; \
799 for d in $(MU_BUILD_ROOT_DIR) \
800 $(SOURCE_PATH_BUILD_ROOT_DIRS) \
801 $(SOURCE_PATH_BUILD_DATA_DIRS); do \
802 $(call build_msg_fn,Git pull $${d}) ; \
803 pushd $${d} >& /dev/null && $(GIT) pull && popd >& /dev/null ; \
804 done ; \
805 $(call build_msg_fn,Git pull build tools) ; \
806 $(call tool_make_target_fn,pull-all) ; \
807 $(call build_msg_fn,Git pull packages for platform $(PLATFORM)) ; \
808 make PLATFORM=$(PLATFORM) $(patsubst %,%-pull-all,$(ROOT_PACKAGES))
809
810.PHONY: %-diff
811%-diff:
812 @$(BUILD_ENV) ; \
813 d=$(call find_source_fn,$(PACKAGE_SOURCE)) ; \
814 $(call build_msg_fn,Git diff $(PACKAGE)) ; \
815 if [ -d $${d}/.git ] ; then \
816 cd $${d} && $(GIT) --no-pager diff 2>/dev/null; \
817 else \
818 $(call build_msg_fn, $(PACKAGE) not a git directory) ; \
819 fi
820
821
822
823# generate diffs for everything in source path
824.PHONY: diff-all
825diff-all:
826 @$(BUILD_ENV) ; \
827 $(call build_msg_fn,Generate diffs) ; \
828 for r in $(ABSOLUTE_SOURCE_PATH); do \
829 for d in $${r}/* ; do \
830 if [ -d $${d} ] ; then \
831 $(call build_msg_fn,Git diff $${d}) ; \
832 if [ -d $${d}/.git ] ; then \
833 cd $${d} && $(GIT) --no-pager diff 2>/dev/null; \
834 else \
835 $(call build_msg_fn, $${d} not a git directory) ; \
836 fi ; \
837 fi ; \
838 done ; \
839 done
840
841######################################################################
842# System images
843######################################################################
844
845IMAGE_DIR = $(MU_BUILD_ROOT_DIR)/image-$(PLATFORM)
846
847# Reports shared libraries in given directory
848find_shared_libs_fn = \
849 find $(1) \
850 -maxdepth 1 \
851 -regex '.*/lib[a-z0-9_]+\+?\+?.so' \
852 -o -regex '.*/lib[a-z0-9_]+-[0-9.]+\+?\+?.so' \
853 -o -regex '.*/lib[a-z0-9_]+\+?\+?.so.[0-9.]+'
854
855# By default pick up files from binary directories and /etc.
856# Also include shared libraries.
857DEFAULT_IMAGE_INCLUDE = \
858 for d in bin sbin libexec \
859 usr/bin usr/sbin usr/libexec \
860 etc; do \
861 [[ -d $$d ]] && echo $$d; \
862 done ; \
863 [[ -d $(arch_lib_dir) ]] \
864 && $(call find_shared_libs_fn,$(arch_lib_dir))
865
866# Define any shell functions needed by install scripts
867image_install_functions = \
868 $(foreach p,$(ALL_PACKAGES), \
869 $(if $($(p)_image_install_functions), \
870 $($(p)_image_install_functions)))
871
872# Should always be over-written by temp dir in %-root-image rule
873IMAGE_INSTALL_DIR = $(error you need to set IMAGE_INSTALL_DIR)
874
875image_install_fn = \
876 @$(BUILD_ENV) ; \
877 $(call build_msg_fn,Image-install $(1) for platform $(PLATFORM)) ; \
878 inst_dir=$(IMAGE_INSTALL_DIR) ; \
879 mkdir -p $${inst_dir} ; \
880 cd $(2) ; \
881 : select files to include in image ; \
882 image_include_files=" \
883 `$(call ifdef_fn,$(1)_image_include,$(DEFAULT_IMAGE_INCLUDE)) ; \
884 echo "" ; \
885 exit 0 ; `"; \
886 : select files regexps to exclude from image ; \
887 image_exclude_files="" ; \
888 if [ ! -z "$($(1)_image_exclude)" ] ; then \
889 image_exclude_files="${image_exclude_files} \
890 $(patsubst %,--exclude=%,$($(1)_image_exclude))" ; \
891 fi ; \
892 [[ -z "$${image_include_files}" || $${image_include_files} == " " ]] \
893 || tar cf - $${image_include_files} $${image_exclude_files} \
894 | tar xf - -C $${inst_dir} ; \
895 : copy files from copyimg directories on source path if present ; \
896 for build_data_dir in $(SOURCE_PATH_BUILD_DATA_DIRS) ; do \
897 d="$${build_data_dir}/packages/$(1).copyimg" ; \
898 if [ -d "$${d}" ] ; then \
899 env $($(PLATFORM)_copyimg_env) \
900 $(MU_BUILD_ROOT_DIR)/copyimg $${d} $${inst_dir} ; \
901 fi ; \
902 done ; \
903 : run package dependent install script ; \
904 $(if $($(1)_image_install), \
905 $(image_install_functions) \
906 cd $${inst_dir} ; \
907 $($(1)_image_install))
908
909.PHONY: %-image_install
910%-image_install: %-install
911 $(call image_install_fn,$(PACKAGE),$(PACKAGE_INSTALL_DIR))
912
913basic_system_image_include = \
914 $(call ifdef_fn,$(PLATFORM)_basic_system_image_include, \
915 echo bin/ldd ; \
916 echo $(arch_lib_dir)/ld*.so* ; \
917 $(call find_shared_libs_fn, $(arch_lib_dir)))
918
919basic_system_image_install = \
920 mkdir -p bin lib mnt proc root sbin sys tmp etc ; \
921 mkdir -p usr usr/{bin,sbin} usr/lib ; \
922 mkdir -p var var/{lib,lock,log,run,tmp} ; \
923 mkdir -p var/lock/subsys var/lib/urandom
924
925.PHONY: basic_system-image_install
926basic_system-image_install: # linuxrc-install
927 $(if $(not_native), \
928 $(call image_install_fn,basic_system,$(TARGET_TOOL_INSTALL_DIR)),)
929
930ROOT_PACKAGES = $(if $($(PLATFORM)_root_packages),$($(PLATFORM)_root_packages),$(default_root_packages))
931
932.PHONY: install-packages
933install-packages: $(patsubst %,%-find-source,$(ROOT_PACKAGES))
934 @$(BUILD_ENV) ; \
935 set -eu$(BUILD_DEBUG) ; \
936 d=$(MU_BUILD_ROOT_DIR)/packages-$(PLATFORM) ; \
937 rm -rf $${d} ; \
938 mkdir -p $${d}; \
939 $(MAKE) -C $(MU_BUILD_ROOT_DIR) IMAGE_INSTALL_DIR=$${d} \
940 $(patsubst %,%-image_install, \
941 basic_system \
942 $(ROOT_PACKAGES)) || exit 1; \
943 $(call build_msg_fn, Relocating ELF executables to run in $${d}) ; \
944 find $${d} -type f \
945 -exec elftool quiet in '{}' out '{}' \
946 set-interpreter \
947 $${d}/$(arch_lib_dir)/$(DYNAMIC_LINKER) \
948 set-rpath $${d}/$(arch_lib_dir):$${d}/lib ';' ; \
949 : strip symbols from files ; \
950 if [ $${strip_symbols:-no} = 'yes' ] ; then \
951 $(call build_msg_fn, Stripping symbols from files) ; \
952 find $${d} -type f \
953 -exec \
954 $(TARGET_PREFIX)strip \
955 --strip-unneeded '{}' ';' \
956 >& /dev/null ; \
957 else \
958 $(call build_msg_fn, NOT stripping symbols) ; \
959 fi
960
961# readonly root squashfs image
962# Note: $(call build_msg_fn) does not seem to work inside of fakeroot so we use echo
963.PHONY: ro-image
964$(PLATFORM_IMAGE_DIR)/ro.img ro-image: $(patsubst %,%-find-source,$(ROOT_PACKAGES))
965 @$(BUILD_ENV) ; \
966 d=$(PLATFORM_IMAGE_DIR) ; \
967 mkdir -p $$d; \
968 ro_image=$$d/ro.img ; \
969 rm -f $${ro_image} ; \
970 tmp_dir="`mktemp -d $$d/ro-image-XXXXXX`" ; \
971 chmod 0755 $${tmp_dir} ; \
972 cd $${tmp_dir} ; \
973 trap "rm -rf $${tmp_dir}" err ; \
974 fakeroot /bin/bash -c "{ \
975 set -eu$(BUILD_DEBUG) ; \
976 $(MAKE) -C $(MU_BUILD_ROOT_DIR) IMAGE_INSTALL_DIR=$${tmp_dir} \
977 $(patsubst %,%-image_install, \
978 basic_system \
979 $(ROOT_PACKAGES)) ; \
980 : make dev directory ; \
981 $(linuxrc_makedev) ; \
982 echo @@@@ Relocating ELF executables to run in / @@@@ ; \
983 find $${d} -type f \
984 -exec elftool quiet in '{}' out '{}' \
985 set-interpreter \
986 /$(arch_lib_dir)/$(DYNAMIC_LINKER) \
987 set-rpath /$(arch_lib_dir):/lib ';' ; \
988 : strip symbols from files ; \
989 if [ '$${strip_symbols:-yes}' = 'yes' ] ; then \
990 echo @@@@ Stripping symbols from files @@@@ ; \
991 find $${tmp_dir} -type f \
992 -exec \
993 $(TARGET_PREFIX)strip \
994 --strip-unneeded '{}' ';' \
995 >& /dev/null ; \
996 else \
997 echo @@@@ NOT stripping symbols @@@@ ; \
998 fi ; \
999 if [ $${sign_executables:-yes} = 'yes' \
1000 -a -n "$($(PLATFORM)_public_key)" ] ; then \
1001 echo @@@@ Signing executables @@@@ ; \
1002 find $${tmp_dir} -type f \
1003 | xargs sign $($(PLATFORM)_public_key) \
1004 $($(PLATFORM)_private_key_passphrase) ; \
1005 fi ; \
1006 : make read-only file system ; \
1007 mksquashfs \
1008 $${tmp_dir} $${ro_image} \
1009 -no-exports -no-progress -no-recovery ; \
1010 }" ; \
1011 : cleanup tmp directory ; \
1012 rm -rf $${tmp_dir}
1013
1014MKFS_JFFS2_BYTE_ORDER_x86_64 = -l
1015MKFS_JFFS2_BYTE_ORDER_i686 = -l
1016MKFS_JFFS2_BYTE_ORDER_ppc = -b
1017MKFS_JFFS2_BYTE_ORDER_mips = -b
1018MKFS_JFFS2_BYTE_ORDER_native = $(MKFS_JFFS2_BYTE_ORDER_$(NATIVE_ARCH))
1019
1020MKFS_JFFS2_SECTOR_SIZE_IN_KBYTES = \
1021 $(call ifdef_fn,$(PLATFORM)_jffs2_sector_size_in_kbytes,256)
1022
1023mkfs_fn_jffs2 = mkfs.jffs2 \
1024 --eraseblock=$(MKFS_JFFS2_SECTOR_SIZE_IN_KBYTES)KiB \
1025 --root=$(1) --output=$(2) \
1026 $(MKFS_JFFS2_BYTE_ORDER_$(BASIC_ARCH))
1027
1028# As things stand the actual initrd size parameter
1029# is set in .../open-repo/build-data/packages/linuxrc.mk.
1030EXT2_RW_IMAGE_SIZE=notused
1031
1032mkfs_fn_ext2 = \
1033 e2fsimage -d $(1) -f $(2) -s $(EXT2_RW_IMAGE_SIZE)
1034
1035RW_IMAGE_TYPE=jffs2
1036
1037make_rw_image_fn = \
1038 $(call mkfs_fn_$(RW_IMAGE_TYPE),$(1),$(2))
1039
1040rw_image_embed_ro_image_fn = \
1041 mkdir -p proc initrd images ro rw union ; \
1042 cp $(PLATFORM_IMAGE_DIR)/$(1) images/$(1) ; \
1043 md5sum images/$(1) > images/$(1).md5 ; \
1044 echo Built by $(LOGNAME) at `date` > images/$(1).stamp ; \
1045 mkdir -p changes/$(1)
1046
1047# make sure RW_IMAGE_TYPE is a type we know how to build
1048.PHONY: rw-image-check-type
1049rw-image-check-type:
1050 @$(BUILD_ENV) ; \
1051 if [ -z "$(make_rw_image_fn)" ] ; then \
1052 $(call build_msg_fn,Unknown read/write fs image type; \
1053 try RW_IMAGE_TYPE=ext2 or RW_IMAGE_TYPE=jffs2) ; \
1054 exit 1; \
1055 fi
1056
1057# read write image
1058.PHONY: rw-image
1059rw-image: rw-image-check-type ro-image
1060 @$(BUILD_ENV) ; \
1061 d=$(PLATFORM_IMAGE_DIR) ; \
1062 mkdir -p $$d ; \
1063 rw_image="$$d/rw.$(RW_IMAGE_TYPE)" ; \
1064 ro_image="ro.img" ; \
1065 rm -f $$rw_image ; \
1066 tmp_dir="`mktemp -d $$d/rw-image-XXXXXX`" ; \
1067 chmod 0755 $${tmp_dir} ; \
1068 cd $${tmp_dir} ; \
1069 trap "rm -rf $${tmp_dir}" err ; \
1070 fakeroot /bin/bash -c "{ \
1071 set -eu$(BUILD_DEBUG) ; \
1072 $(linuxrc_makedev) ; \
1073 $(call rw_image_embed_ro_image_fn,$${ro_image}) ; \
1074 $(call make_rw_image_fn,$${tmp_dir},$${rw_image}) ; \
1075 }" ; \
1076 : cleanup tmp directory ; \
1077 rm -rf $${tmp_dir}
1078
1079images: linuxrc-install linux-install $(image_extra_dependencies) rw-image
1080 @$(BUILD_ENV) ; \
1081 d=$(PLATFORM_IMAGE_DIR) ; \
1082 cd $(BUILD_DIR)/linux-$(PLATFORM) ; \
1083 i="" ; \
1084 [[ -z $$i && -f bzImage ]] && i=bzImage ; \
1085 [[ -z $$i && -f zImage ]] && i=zImage ; \
1086 [[ -z $$i && -f linux ]] && i=linux ; \
1087 [[ -z $$i && -f vmlinux ]] && i=vmlinux ; \
1088 [[ -z $$i ]] \
1089 && $(call build_msg_fn,no linux image to install \
1090 in $(BUILD_DIR)/linux-$(PLATFORM)) \
1091 && exit 1 ; \
1092 cp $$i $$d
1093
1094######################################################################
1095# Tool chain build/install
1096######################################################################
1097
1098.PHONY: ccache-install
1099ccache-install:
1100 $(MAKE) -C $(MU_BUILD_ROOT_DIR) ccache-build
1101 mkdir -p $(TOOL_INSTALL_DIR)/ccache-bin
1102 ln -sf $(MU_BUILD_ROOT_DIR)/build-tool-native/ccache/ccache \
1103 $(TOOL_INSTALL_DIR)/ccache-bin/$(TARGET_PREFIX)gcc
1104
1105TOOL_MAKE = $(MAKE) is_build_tool=yes
1106
1107tool_make_target_fn = \
1108 $(if $(strip $(NATIVE_TOOLS)), \
1109 $(TOOL_MAKE) $(patsubst %,%-$(1),$(NATIVE_TOOLS)) ARCH=native || exit 1 ;) \
1110 $(TOOL_MAKE) $(patsubst %,%-$(1),$(CROSS_TOOLS))
1111
1112.PHONY: install-tools
1113install-tools:
1114 $(call tool_make_target_fn,install)
1115
1116.PHONY: bootstrap-tools
1117bootstrap-tools:
1118 $(TOOL_MAKE) make-install findutils-install git-install \
1119 automake-install autoconf-install libtool-install fakeroot-install
1120
1121
1122######################################################################
1123# Clean
1124######################################################################
1125
1126package_clean_script = \
1127 @$(call build_msg_fn, Cleaning $* in $(PACKAGE_INSTALL_DIR)) ; \
1128 $(BUILD_ENV) ; \
1129 $(if $(is_build_tool),,rm -rf $(PACKAGE_INSTALL_DIR) ;) \
1130 rm -rf $(TIMESTAMP_DIR)/$(call timestamp_name_fn,*) ; \
1131 $(if $($(PACKAGE)_clean), \
1132 $($(PACKAGE)_clean), \
1133 $(PACKAGE_MAKE) clean)
1134
1135.PHONY: %-clean
1136%-clean:
1137 $(package_clean_script)
1138
1139# Wipe e.g. remove build and install directories for packages.
1140package_wipe_script = \
1141 @message=$(if $(is_build_tool),"Wiping build $(PACKAGE)","Wiping build/install $(PACKAGE)") ; \
1142 $(call build_msg_fn,$$message) ; \
1143 $(BUILD_ENV) ; \
Damjan Marion6bbf83a2017-01-10 10:39:21 +01001144 rm -rf $(if $(is_build_tool),$(PACKAGE_BUILD_DIR),$(PACKAGE_INSTALL_DIR) $(PACKAGE_BUILD_DIR))
Ed Warnickecb9cada2015-12-08 15:45:58 -07001145
1146.PHONY: %-wipe
1147%-wipe:
1148 $(package_wipe_script)
1149
1150# Wipe entire build/install area for TAG and PLATFORM
1151.PHONY: wipe-all
1152wipe-all:
1153 @$(call build_msg_fn, Wiping $(BUILD_DIR) $(INSTALL_DIR)) ; \
1154 $(BUILD_ENV) ; \
1155 rm -rf $(BUILD_DIR) $(INSTALL_DIR)
1156
1157# Clean everything
1158distclean:
1159 rm -rf $(MU_BUILD_ROOT_DIR)/$(BUILD_PREFIX_package)*/
1160 rm -rf $(MU_BUILD_ROOT_DIR)/$(BUILD_PREFIX_tool)*
1161 rm -rf $(MU_BUILD_ROOT_DIR)/$(INSTALL_PREFIX)*
1162 rm -rf $(MU_BUILD_ROOT_DIR)/$(IMAGES_PREFIX)*
1163 rm -rf $(TOOL_INSTALL_DIR)
1164 rm -rf $(MU_BUILD_ROOT_DIR)/*.deb
Ed Warnicke46040a52016-03-22 12:52:22 -05001165 rm -rf $(MU_BUILD_ROOT_DIR)/*.rpm
Ed Warnickecb9cada2015-12-08 15:45:58 -07001166 rm -rf $(MU_BUILD_ROOT_DIR)/*.changes
Klement Sekeraf62ae122016-10-11 11:47:09 +02001167 rm -rf $(MU_BUILD_ROOT_DIR)/python
Ed Warnicke46040a52016-03-22 12:52:22 -05001168 if [ -e /usr/bin/dh ];then (cd $(MU_BUILD_ROOT_DIR)/deb/;debian/rules clean); fi
Ed Warnickecb9cada2015-12-08 15:45:58 -07001169 rm -f $(MU_BUILD_ROOT_DIR)/deb/debian/*.install
Ed Warnickecb9cada2015-12-08 15:45:58 -07001170 rm -f $(MU_BUILD_ROOT_DIR)/deb/debian/changelog